//
//  TAPPXMediationBannerAd.m
//
//  Created by Tappx on 28/05/15.
//
//

#import "TappxMediationBannerAd.h"


@implementation TappxMediationBannerAd

@synthesize delegate;

- (void)dealloc {
    if(_tappxBanner!=nil){
        [_tappxBanner removeBanner];
        _tappxBanner=nil;
    }
    if ( _adView != nil )
        _adView = nil;
    
}

- (void)requestBannerAd:(GADAdSize)adSize
              parameter:(NSString *)serverParameter
                  label:(NSString *)serverLabel
                request:(GADCustomEventRequest *)request{
    NSString* adUnit = serverParameter;

    
    if ( adUnit != nil ) {
        
        NSArray *elements = [adUnit componentsSeparatedByString:@"|"];
        NSString* key = [elements objectAtIndex: 0];
        
        NSString* isTest = nil;
        if ( [elements count]  > 1 )
            isTest = [elements objectAtIndex: 1];
        
        if ( isTest != nil && [isTest isEqualToString:@"1" ] )
            [TappxFramework addTappxKey:key testMode:YES];
        else {
            [TappxFramework addTappxKey:key];
        }
    }
    else{
        [self.delegate customEventBanner:self didFailAd:[NSError errorWithDomain:kGADErrorDomain code:kGADErrorInvalidRequest userInfo:nil]];
        return;
    }

    
    TappxBannerSize size = TappxBannerSmartBanner;
    CGRect sizeFrame = CGRectMake(0, 0, ((UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone) ? 320 : 728 ), ((UI_USER_INTERFACE_IDIOM()==UIUserInterfaceIdiomPhone) ? 50 : 90 ));
    if ( adSize.size.width == 320 && adSize.size.height == 50 ){
        size = TappxBannerSize320x50;
        sizeFrame = CGRectMake(0, 0, 320, 50);
    }else if ( adSize.size.width == 728 && adSize.size.height == 90 ){
        size = TappxBannerSize728x90;
        sizeFrame = CGRectMake(0, 0, 728, 90);
    }else if ( adSize.size.width == 300 && adSize.size.height == 250 ){
        
        size = TappxBannerSize300x250;
        sizeFrame = CGRectMake(0, 0, 300, 250);
    }
    
    _adView = [[UIView alloc] initWithFrame:sizeFrame];
    _tappxBanner = [[TappxBannerViewController alloc] initWithDelegate:self andSize:size andView:_adView ];
    [_tappxBanner load];

}

//TAPPXBannerDelegate

-(UIViewController*)presentViewController{
    return [self.delegate viewControllerForPresentingModalView];
}

-(void) tappxBannerViewControllerDidFinishLoad:(TappxBannerViewController*) vc {
    [self.delegate customEventBanner:self didReceiveAd:_adView];
}

-(void) tappxBannerViewControllerDidPress:(TappxBannerViewController*) vc {
    [self.delegate customEventBannerWillLeaveApplication:self];
}
-(void) tappxBannerViewControllerDidFail:(TappxBannerViewController*) vc withError:(TappxErrorAd*) error {
    
    NSError* _error = [self convertError:error];
    [self.delegate customEventBanner:self didFailAd:_error];
    
    if(_tappxBanner!=nil){
        [_tappxBanner removeBanner];
        _tappxBanner=nil;
    }
    if ( _adView != nil )
        _adView = nil;
}
-(void) tappxBannerViewControllerDidClose:(TappxBannerViewController*) vc {
    
    [self.delegate customEventBannerDidDismissModal:self];
}

- (NSError *) convertError:(TappxErrorAd *)error {
    switch ( error.errorCode ) {
        case DEVELOPER_ERROR:
            return [NSError errorWithDomain:kGADErrorDomain code:kGADErrorInternalError userInfo:nil];
            break;
        case NO_CONNECTION:
            return [NSError errorWithDomain:kGADErrorDomain code:kGADErrorServerError userInfo:nil];
            break;
        case NO_FILL:
        default:
            return [NSError errorWithDomain:kGADErrorDomain code:kGADErrorNoFill userInfo:nil];
            break;
    }
}


@end
